#include <stdlib.h>
#include <fcntl.h> //read()
#include <unistd.h> //write()
#include <string.h> //strlen

#include <klee/klee.h>

class Cat {
public:
	int weight;
};

Cat* create_cat(int weight) {
	Cat* c = 0;
	return c;
}

int get_weight(Cat* c) { return c->weight; }

int null_pointer() {
	Cat* c = 0;
	return c->weight;
}

int null_pointer2() {
	Cat* c = create_cat(11);
	return get_weight(c);
}

void fileNotClosed() {
	int fd = open("test_file.txt", O_WRONLY | O_CREAT | O_TRUNC, 0600);
	if (fd != -1) {
		char buffer[256];
		write(fd, buffer, strlen(buffer));
	}
	// Missing close(fd)
}

void double_free() {
	int* p;
	p = (int*)malloc(sizeof(int));
	free(p);
	free(p); //Double free()
}

void memory_leak() {
	int* p;
	p = (int*)malloc(sizeof(int));
	//missing free(p);
}

void realloc_leak() {
	int *p, *q;
	p = (int*)malloc(sizeof(int));
	q = (int*)realloc(p, sizeof(int) * 42);

	if (q != NULL)
		free(q);
	//missing else branch: if realloc failed (i.e. q == NULL), the original pointer (i.e. p) needs to be freed
}

int main (int argc, char **argv) {
	int branch;

	klee_make_symbolic(&branch, sizeof(branch), "branch");
	klee_assume(branch <= 7);

	switch(branch) {
	case 0:
		fileNotClosed();
		break;
	case 1:
		memory_leak();
		break;
	case 2:
		realloc_leak();
		break;
	case 3:
		null_pointer();
		break;
	case 4:
		double_free();
		break;
	case 5:
		null_pointer2();
		break;
	case 6:
		abort();
		break;
	default:
		break;
	}

	return 0;
}
